#include <iostream>
#include <iomanip>
#include <fstream>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cell-event.h"
#include "rof-event.h"

using namespace std;

// ܓxEoxEox30b̒EőlEԒlEŏlE[̃Obhǂ߂B
// 30b(1km)f̊iqTCYłBlatitude(ܓx)̃ObhTCY͖111.2kmœłB
// longitude(ox)̃TCY͈ܓxɂĈقȂ̂ŌvZKvB

// vZł͍łk()̍s0sƍlĂB(20120211)

void Cell::setLocation (
	int rowStep, // row counter
	int colStep, // column counter
	int nRow, // number of row for the study area
	int nCol, //number of column for the study area
	float SWlat, // South west corner of latitude
	float SWlon // South west corner of longitude
)
{
	int numberOfGrid =1; // ̃Obh\Z
	
	// setting latitude in 'sec' unit
	latitude  = (SWlat*3600) + 30*numberOfGrid*(nRow-rowStep-1) + 15*numberOfGrid;

	// setting longitude in 'sec' unit
	longitude = (SWlon*3600) + 30*numberOfGrid*colStep + 15*numberOfGrid;

	// setting length (km) for 1 degree in longitude direction
	longitudinalLength = (float)926.6*(float)cos(latitude/3600.0/180.0*3.14);	//92.6886: gridcell size at equator in meter (3s ~ 92.6886 m).

}

/* ̃Obh܂܂ROFZ߂ */
void Cell::setROFCell(ROF** fROF, int row_ROF, int col_ROF)
{
	double x=(double)latitude/3600.0;
	double y=(double)longitude/3600.0;
	double distance;
	double distance_min;

	distance_min=100000000000000000000000000000.0;
	
	for(int i=0; i<row_ROF; i++){
		for(int j=0; j<col_ROF; j++){

			distance = sqrt(pow(x-(double)fROF[i][j].latitude, 2.0)+pow(y-(double)fROF[i][j].longitude, 2.0));
			
			if(distance < distance_min){
				
				ROFCell=&fROF[i][j];
				distance_min = distance;
			}
		}
	}
}
